#!/usr/bin/python

import time

class MuteState:
    def __init__(self, gpio_handler):
        self.mute_state = "off"
        self.previous_state = "off"
        self.gpio_handler = gpio_handler

    
    def mute_thread(self):
        self.running = True
        mute = True
        while self.running:
            if self.mute_state == "10hz_mute":
                if self.previous_state != '10hz_mute':
                    mute = True
                    switch_time = time.time()
                    self.gpio_handler.all_mute(mute)
                    self.previous_state = '10hz_mute'
                else:
                    if time.time() - switch_time > 0.1:
                        mute = not mute
                        self.gpio_handler.all_mute(mute)
                        switch_time = time.time()

            elif self.mute_state == "1hz_mute":
                if self.previous_state != '1hz_mute':
                    mute = True
                    switch_time = time.time()
                    self.gpio_handler.all_mute(mute)
                    self.previous_state = '1hz_mute'
                else:
                    if time.time() - switch_time > 1:
                        mute = not mute
                        self.gpio_handler.all_mute(mute)
                        switch_time = time.time()

            elif self.mute_state == "off":
                mute = False
                if self.previous_state != 'off':
                    self.gpio_handler.all_mute(mute)
            else:
                print "ERROR: invalid state: " + self.mute_state
	    time.sleep(0.05)
    def set_state(self, state):
        self.previous_state = self.mute_state
        self.mute_state = state

if __name__ == '__main__':
    mutestate = MuteState()
    #ledstate.set_state("error")
    mutestate.mute_thread()
